'use strict';

function _defaults(obj, defaults) { var keys = Object.getOwnPropertyNames(defaults); for (var i = 0; i < keys.length; i++) { var key = keys[i]; var value = Object.getOwnPropertyDescriptor(defaults, key); if (value && value.configurable && obj[key] === undefined) { Object.defineProperty(obj, key, value); } } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : _defaults(subClass, superClass); }

/**
 * List Component for uxcore
 * @author eternalsky
 *
 * Copyright 2015-2016, Uxcore Team, Alinw.
 * All rights reserved.
 */
var React = require('react');
var i18n = require('./i18n');

var ListCore = function (_React$Component) {
  _inherits(ListCore, _React$Component);

  function ListCore(props) {
    _classCallCheck(this, ListCore);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _this.state = {};
    return _this;
  }

  ListCore.prototype.renderItems = function renderItems() {
    var me = this;
    var _me$props = me.props;
    var prefixCls = _me$props.prefixCls;
    var data = _me$props.data;
    var renderItem = _me$props.renderItem;
    var locale = _me$props.locale;
    var emptyText = _me$props.emptyText;

    if (data) {
      return data.map(function (item, index) {
        return React.createElement(
          'div',
          { className: prefixCls + '-item', key: index },
          renderItem(item)
        );
      });
    }
    return React.createElement(
      'div',
      { className: prefixCls + '-nodata' },
      i18n[locale].nodata
    );
  };

  ListCore.prototype.render = function render() {
    var me = this;
    var prefixCls = me.props.prefixCls;

    return React.createElement(
      'div',
      { className: prefixCls + '-core' },
      me.renderItems()
    );
  };

  return ListCore;
}(React.Component);

ListCore.defaultProps = {
  prefixCls: 'kuma-list'
};

// http://facebook.github.io/react/docs/reusable-components.html
ListCore.propTypes = {
  prefixCls: React.PropTypes.string,
  data: React.PropTypes.array,
  renderItem: React.PropTypes.func
};

ListCore.displayName = 'ListCore';

module.exports = ListCore;